/*
 * NimBLE_Scan_Whitelist demo
 *
 * Created May 16, 2021
 * Author: h2zero
 */

#include <Arduino.h>
#include <NimBLEDevice.h>
#include <PrintEx.h>
StreamEx mySerial = Serial;

NimBLEScan *pBLEScan;
NimBLEAddress a("e8:f5:7d:2f:ab:b4");
uint lastAdv = millis();

class ScanCallbacks : public NimBLEScanCallbacks {
    void onResult(const NimBLEAdvertisedDevice* advertisedDevice) override {
        //Serial.printf("Advertised Device: %s \n", advertisedDevice->toString().c_str());
        /*
         * Here we add the device scanned to the whitelist based on service data but any
         * advertised data can be used for your preferred data.
         */
        mySerial.printf("%d: Found %s with RSSI %d \n", millis() -lastAdv, advertisedDevice->getAddress().toString().c_str(), advertisedDevice->getRSSI());
        lastAdv = millis();
        //pBLEScan->clearResults(); // comment-out 1
    }
} scanCallbacks;

void setup() {
    Serial.begin(460800);
    NimBLEDevice::setScanDuplicateCacheSize(10); //comment-out 2
    NimBLEDevice::init("");
    NimBLEDevice::whiteListAdd(a);
    Serial.println("Scanning...");
    pBLEScan = NimBLEDevice::getScan();
    pBLEScan->setScanCallbacks(&scanCallbacks);
    pBLEScan->setFilterPolicy(BLE_HCI_SCAN_FILT_USE_WL);
    pBLEScan->setMaxResults(0); // do not store the scan results, use callback only.
}

void loop() {
    if(pBLEScan->isScanning() == false) {
        pBLEScan->start(0, nullptr, false);
    }
    Serial.println("Looping...");
    delay(2000);
}
